config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root to: "emails#index"
  resources :tasks, except: [:show]
  resources :emails
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/category.rb
class Category < ApplicationRecord
  has_many :tasks
end

app/models/email.rb
class Email < ApplicationRecord
end

app/models/task.rb
class Task < ApplicationRecord
  validates :title, presence: true
  belongs_to :category
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/emails_controller.rb
class EmailsController < ApplicationController

	def index
		@emails = Email.all
	end

	def create
		@email = Email.new(object: Faker::Beer.brand, body: Faker::Lorem.paragraph_by_chars(number: 256, supplemental: false))
		if @email.save
		  respond_to do |format|
		    format.html { redirect_to root_path }
		    format.js { }
		  end
		  flash[:notice] = "Email created"
		else
		  redirect_to root_path
		  flash[:notice] = "Please try again"
		end
	end

	def show
		@email = Email.find(params[:id])
		@email.update(read:true)
		respond_to do |format|
		  format.html { redirect_to root_path }
		  format.js { }
		end
	end

	def destroy
	  @email = Email.find(params[:id])

	  if @email.destroy
	    respond_to do |format|
	      format.js { }
	    end
	  end
	end

	def update
		@email = Email.find(params[:id])
		if @email.read == false
			@email.update(read:true)
		elsif @email.read == true
			@email.update(read:false)
		end
		respond_to do |format|
		  format.html { redirect_to root_path }
		  format.js { }
		end
	end

end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
    @tasks = Task.all
    @categories = Category.all
  end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
before_action :authenticate_user!
  def new
    @categories = Category.all
  end

  def create
    @task = Task.new(task_params)
    @category = Category.find(category_params)
    @task.category = @category
    if @task.save
      respond_to do |format|
        format.html { redirect_to root_path }
        format.js { }
      end
      flash[:notice] = "Task created"
    else
      redirect_to root_path
      flash[:notice] = "Please try again"
    end
  end

  def edit
    @task = Task.find(params[:id])
    @categories = Category.all

  end

  def update
    @task = Task.find(params[:id])
    if @task.status == false
       @task.update(status:true)
       respond_to do |format|
         format.html { redirect_to root_path }
         format.js { }
       end
    elsif @task.status == true
      @task.update(status:false)
      respond_to do |format|
        format.html { redirect_to root_path }
        format.js { }
      end
    end
  end

  def index
    @tasks = Task.all
  end

  def destroy
    @task = Task.find(params[:id])

    if @task.destroy
      respond_to do |format|
        format.html { redirect_to root_path }
        format.js { }
      end
    end
  end


  private

  def task_params
    params.permit(:title, :deadline, :description, :status)
  end

  def category_params
    params.require(:Category)
  end


end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/home/index.html.erb
<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.15.1/css/all.css" integrity="sha384-vp86vTRFVJgpjF9jiIGPEEqYqlDwgyBgEF109VFjmqGmIY/Y4HV4d3Gp2irVfcrp" crossorigin="anonymous">

<h1 class="text-center mb-4">Welcome to my todolist app</h1>
<%= render 'layouts/task_form'  %>
<div class="container">
  <ul id="tasks-group">
  <% @categories.each do  |category|%>
  <li><%= category.title  %></li>
  <div class="card-<%= category.id %>">
    <ul id="task-list">
      <% category.tasks.each do |task|  %>
      <li id="id-<%= task.id %>" style="text-decoration: line-through;" >
        <%= task.title  %>
        <% unless task.deadline.nil? %>
          , to read: <%= task.deadline.strftime('%D')  %>
          <%= link_to task_path(task), :method => "delete", data: { confirm: 'Are you sure?', remote: true } do %>
            <span><i class="fas fa-trash"></i></span>
          <% end %>
          <%= check_box_tag :status, 1, task.status, data: { remote: true, url: task_path(task), params: { status: task.status}.to_param, method: "put" }%>
        <% end %>
      </li>
      <% end %>
    </ul>
  </div>
  <% end %>
  </ul>
</div>

<div class="container">
  <div class="row" id="task-image">
    <% @tasks.each do |task|  %>
      <div class="card col-3">
        <% unless task.image.nil? %>
          <%= image_tag task.image, class: "rounded-circle" %>
        <% end %>
      </div>
    <% end %>
  </div>
</div>

app/views/layouts/_flash.html.erb
<p class="notice"><%= notice %></p>
<p class="alert"><%= alert %></p>

app/views/layouts/_navbar.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo03" aria-controls="navbarTogglerDemo03" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
    <%= link_to "Sandbox App", root_path, class: "navbar-brand" %>
  <div class="collapse navbar-collapse" id="navbarTogglerDemo03">
    <ul class="navbar-nav mr-auto mt-2 mt-lg-0">

      <% unless user_signed_in? %>
      <li class="nav-item">
        <%= link_to "Log in", new_user_session_path, class: "nav-link" %>
      </li>
      <li class="nav-item">
        <%= link_to "Sign up", new_user_registration_path, class: "nav-link" %>
      </li>
      <% else %>
      <li class="nav-item">
        <%= link_to "Log out", destroy_user_session_path, method: :delete, class: "nav-link" %>
      </li>
      <% end %>
      <li class="nav-item">
        <%= link_to "New task", new_task_path, class: "nav-link" %>
      </li>
      
    </ul>
        <img class="rounded-circle" height="50px" width="50px" src="http://digitalspyuk.cdnds.net/17/25/320x320/square-1498216547-avatar-neytiri.jpg">
  </div>
</nav>

app/views/layouts/_task_form.html.erb
<div class="container">

  <div class="row ml-3">
      <div class="offset-md-3 col-md-6 offset-md-3">
          <%= form_tag(tasks_path, method: "post", class: "form", id: "contact-form", remote: true)  do %>

              <div class="form-group">
                  <%= label_tag "Task", nil, class: "form-label" %>
                  <%= text_field_tag :title, nil, class: "form-control", placeholder: "Buy burgers" %>
              </div>
              <div class="form-group">
                  <%= label_tag "Deadline", nil, class: "form-label" %>
                  <%= date_field_tag :deadline, nil, class: "form-control" %>

              </div>
              <div class="form-group">
                  <%= label_tag "Category", nil, class: "form-label" %>
                  <%= select_tag "Category", options_from_collection_for_select(@categories, "id", "title", "1"), class: "form-control"  %>
              </div>

              <div class="text-center">
                  <%= submit_tag("Create task", class: "btn btn-start-order") %>
              </div>
          <%end%>
      </div>
  </div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TodolistApp</title>
    <!-- Bootstrap CSS -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
    <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
  </head>

  <body>
    <%= render 'layouts/navbar'  %>
    <%= render 'layouts/flash'  %>
    <%= yield %>
  </body>
</html>

app/views/tasks/_task.html.erb
<li><%= task.title %> , to read: <%= task.deadline.strftime('%D') %>          <%= link_to task_path(task), :method => "delete", data: { confirm: 'Are you sure?', remote: true } do %>
            <span><i class="fas fa-trash"></i></span>
          <% end %></li> 

app/views/tasks/_task_list.html.erb
<ul>
  <% @tasks.each do |task|  %>
    <li>
      <%= task.title %>,
      "Deadline : " <%=  task.deadline.strftime("%D")  %>
       <%= link_to "Edit this task", edit_task_path(task) %>
    </li>
  <% end %>
</ul>

app/views/tasks/create.js.erb
document.getElementById("email-table").insertAdjacentHTML("beforeend", "<%= j render 'task', task: @task %>");

app/views/tasks/destroy.js.erb
document.getElementById("id-<%=@task.id%>").remove();

app/views/tasks/edit.html.erb
<h4>Edit your task</h4>
<%= form_tag(task_path, method: "put") do %>
  <div class="form-group">
      <%= label_tag("Your task:") %>
      <%= text_field_tag(:title, @task.title) %>
  </div>

  <div class="form-group">
    <%= label_tag("When is it due for ?") %>
    <%= date_field_tag(:deadline, @task.deadline)  %>
  </div>
    <%= submit_tag("Edit task", class: "btn btn-info") %>
<% end %>
<%= link_to "Delete this task", task_path(@task), method: :delete, class: "btn btn-danger" %>

app/views/tasks/index.html.erb
<% if user_signed_in? %>

  <%= render 'task_list'  %>

<% end %>

<%= link_to "Create a new task", new_task_path, class: "btn btn-info"  %>

app/views/tasks/new.html.erb
<% if user_signed_in? %>
  <%= render 'layouts/task_form'  %>
<% end %>

app/views/tasks/update.js.erb
if ("<%= escape_javascript @task.status%>" == false) {
	document.getElementById("id-<%= escape_javascript @task.id%>").getElementsByTagName("input")[0].checked = false;
	document.getElementById("id-<%= escape_javascript @task.id%>").style.color ="red";

}
else {
	document.getElementById("<%= escape_javascript @task.id%>").getElementsByTagName("input")[0].checked = true;
};